﻿using Microsoft.Xna.Framework.Graphics;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace MathGame
{
    class Animation
    {
        List<AnimSlide> slides;
        int time, timeNow, slideNow;

        public void AddSlide(AnimSlide a)
        {
            slides.Add(a);
            time += a.Time;
        }

        public Animation()
        {
            slides = new List<AnimSlide>();
            time = 0;
            timeNow = 0;
            slideNow = 0;
        }

        public void Reset()
        {
            timeNow = 0;
        }

        public void Update(int timeElap)
        {
            timeNow += timeElap;
            timeNow %= time;

            int tmp = 0;
            slideNow = -1;
            while (tmp <= timeNow)
            {
                slideNow++;
                tmp += slides[slideNow].Time;
            }
        }

        public Texture2D GetSprite()
        {
            return slides[slideNow].Sprite;
        }

        public Texture2D GetSprite(int a)
        {
            return slides[a].Sprite;
        }
    }
}
