﻿using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace MathGame
{
    class Block : TextRect
    {
        private static List<Color> cols;
        private static Random rnd;
        private double value;

        public double Value
        {
            get { return this.value; }
        }

        public Block(int x, int y, int w, int h, Texture2D background, SpriteFont font, double result)
            : base(background, font)
        {
            if (rnd == null) rnd = new Random();

            this.value = result;
            bool colOk;
            Color bgCol;
            cols = new List<Color>();

            do {
                bgCol = Color.FromNonPremultiplied(rnd.Next(256), rnd.Next(256), rnd.Next(256), rnd.Next(150, 201));
                colOk = true;
                foreach (Color c in cols) {
                    if (bgCol == c) {
                        colOk = false;
                        break;
                    }
                }
            } while (!colOk);

            cols.Add(bgCol);
            base.Init(x, y, w, h, Color.Black, bgCol, eJustification.J_CENTER);
            base.SetText(result.ToString());
        }

        public Rectangle GetBlockRect()
        {
            return base.pos;
        }

    }
}
