﻿using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace MathGame
{
    class CheckBox : TextRect
    {
        private static Texture2D _checkSprite;
        private UsrPrm _prm;
        private bool _oldClicked;
        private bool _clicked;
        private bool _checked;

        public CheckBox(Texture2D background, SpriteFont font, UsrPrm prm, Texture2D checkSprite = null)
            : base(background, font)
        {
            if(checkSprite != null)
                _checkSprite = checkSprite;
            _oldClicked = false;
            _clicked = false;
            _checked = ((string)prm.GetValue() == "Ano");
            base.SetText(prm.hint);
            _prm = prm;
        }

        public Rectangle GetBlockRect()
        {
            return base.pos;
        }

        public void Update(MouseState ms, int elapsedTime)
        {
            _clicked = ms.LeftButton == ButtonState.Pressed;
            if(_oldClicked && !_clicked)
            {
                Vector2 m_pos = ms.Position.ToVector2();
                if (m_pos.X >= base.pos.X && m_pos.X <= base.pos.X + base.pos.Width
                    && m_pos.Y >= base.pos.Y && m_pos.Y <= base.pos.Y + base.pos.Height)
                {
                    _checked = !_checked;
                    _prm.SetValue((_checked ? 1 : (object)0));
                }
            }
            _oldClicked = _clicked;
        }

        public void Draw(SpriteBatch spriteBatch)
        {
            base.Draw(spriteBatch);

            if (_checked)
            {
                Rectangle rect = new Rectangle(base.pos.X - _checkSprite.Width, base.pos.Y, _checkSprite.Width, base.pos.Height);
                spriteBatch.Draw(_checkSprite, rect, Color.Yellow);
            }
        }

    }
}
