﻿using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace MathGame
{
    class EnumTextRect : TextRect
    {
        private UsrPrm _prm;
        private bool _oldClicked;
        private bool _clicked;

        public EnumTextRect(Texture2D background, SpriteFont font, UsrPrm prm)
            : base(background, font)
        {
            _oldClicked = false;
            _clicked = false;
            _prm = prm;
            base.SetText(prm.hint + ": " + (string)prm.GetValue());

        }

        public void Update(MouseState ms, int elapsedTime)
        {
            _clicked = ms.LeftButton == ButtonState.Pressed;
            if (_oldClicked && !_clicked)
            {
                Vector2 m_pos = ms.Position.ToVector2();
                if (m_pos.X >= base.pos.X && m_pos.X <= base.pos.X + base.pos.Width
                    && m_pos.Y >= base.pos.Y && m_pos.Y <= base.pos.Y + base.pos.Height)
                {
                    _prm.SetValue(++_prm.value.i);
                    base.SetText(_prm.hint + ": " + (string)_prm.GetValue());
                }
            }
            _oldClicked = _clicked;
        }
    }
}
